;************************************************************************
;* Sega Mark III BG Test Ver 0.01					*
;*									*
;* Programed By Enri (T.H)						*
;************************************************************************




;************************************************************************
;* CPU Initialize							*
;*									*
;*									*
;************************************************************************
ORG	00000H
	DI
	IM	1
	LD	SP,0DFFFH
	JR	MAIN
;************************************************************************
;* RST 008H Set VDP Address						*
;*									*
;************************************************************************
;* IN:DE=VDP Address							*
;************************************************************************
ORG	00008H
	LD	A,E
	OUT	(0BFH),A
	LD	A,D
	OUT	(0BFH),A
	RET

;************************************************************************
;* RST 010H								*
;*									*
;************************************************************************
ORG	00010H

	RET

;************************************************************************
;* RST 018H								*
;*									*
;************************************************************************
ORG	00018H

	RET
;************************************************************************
;* RST 020H								*
;*									*
;************************************************************************
ORG	00020H

	RET
;************************************************************************
;* RST 028H								*
;*									*
;************************************************************************
ORG	00028H

	RET
;------------------------------------------------------------------------
;************************************************************************
;* V-Sync 								*
;*									*
;*									*
;************************************************************************
ORG	00038H

	RETI
;------------------------------------------------------------------------
;************************************************************************
;* Pause Key								*
;*									*
;*									*
;************************************************************************
ORG	00066H

	RETN

;------------------------------------------------------------------------
;************************************************************************
;* Main	Program								*
;*									*
;*									*
;************************************************************************
MAIN:	CALL	PSGOFF
	CALL	VDPINI

	LD	HL,0C000H	;Worak Area Clear
	LD	DE,0C001H
	LD	BC,01FFFH
	LD	(HL),000H
	LDIR

;++++++++++++++++++++
;+ V-RAM Area Clear +
;++++++++++++++++++++
	LD	DE,04000H
	LD	BC,02000H
	LD	HL,00000H
	CALL	VRAMFL
	EI
;
;
;

	LD	A,0E0H		;Screen On
	OUT	(0BFH),A
	LD	A,081H
	OUT	(0BFH),A
	EI

	CALL	SPTOFF

	CALL	SETCHP
	CALL	SETCOL


	LD	DE,07800H
	LD	BC,00380H
	LD	HL,02000H
	CALL	VRAMFL



	LD	DE,07800H
	RST	008H
	LD	B,006H
LP0:	PUSH	BC

	LD	A,000H		;Chr #00
	CALL	PRINT
	LD	A,004H		;Chr #04
	CALL	PRINT
	LD	A,008H		;Chr #08
	CALL	PRINT
	LD	A,00CH		;Chr #0C
	CALL	PRINT

	POP	BC
	DJNZ	LP0
;+++++++++++++++
;+ Program End +
;+++++++++++++++
LOOPM:	NOP
	JP	LOOPM
;------------------------------------------------------------------------
;*********
;* Print *
;*********
PRINT:	LD	H,A

	LD	B,008H
LPPRI:	CALL	PRTOLN
	LD	A,H
	DJNZ	LPPRI

	RET

;******************
;* Print One Line *
;******************
;IN: A=Patten Code(Under)
PRTOLN:	PUSH	BC


	LD	B,004H
LPPL0:	OUT	(0BEH),A

	PUSH	AF		;Set Atr
	LD	A,000H
	OUT	(0BEH),A
	POP	AF

	INC	A
	DJNZ	LPPL0

	POP	BC
	RET
;------------------------------------------------------------------------

;************************************************************************
;* VDP Initialize							*
;*									*
;************************************************************************
VDPINI:	LD	HL,VDPREG
	LD	BC,016BFH
	OTIR
	RET

;------------
;/ Reg Data /
;------------
VDPREG:	DB	016H,080H,0A0H,081H,0FFH,082H,0FFH,083H
	DB	0FFH,084H,0FFH,085H,0FBH,086H,000H,087H
	DB	000H,088H,000H,089H,0FFH,08AH
;------------------------------------------------------------------------
;************************************************************************
;* Sprite Off		 						*
;*									*
;************************************************************************
SPTOFF:	LD	DE,07F00H	;Sprite Y
	LD	HL,0E0E0H
	LD	BC,00020H
	CALL	VRAMFL
	RET
;------------------------------------------------------------------------
;************************************************************************
;* Set Character Pattern 						*
;*									*
;************************************************************************
SETCHP:	LD	HL,CPDATA
	LD	DE,04000H
	LD	BC,16*32
	CALL	TRSVDP
	RET

;------------------------------------------------------------------------
;************************************************************************
;* Set Color Data	 						*
;*									*
;************************************************************************
SETCOL:	LD	HL,CLDATA
	LD	DE,0C000H
	LD	BC,032
	CALL	TRSVDP
	RET

;------------------------------------------------------------------------
;************************************************************************
;* PSG OFF								*
;*									*
;************************************************************************
PSGOFF:	LD	A,09FH
	OUT	(07FH),A
	LD	A,0BFH
	OUT	(07FH),A
	LD	A,0DFH
	OUT	(07FH),A
	LD	A,0FFH
	OUT	(07FH),A
	RET

;------------------------------------------------------------------------
;************************************************************************
;* V-RAM Fill (2Byte)							*
;*									*
;************************************************************************
;* IN:DE=VDP Address							*
;*    BC=Length								*
;*     H=Store Data 1,L=Store Data 2					*
;************************************************************************
VRAMFL:	RST	008H
LPVRMF:	LD	A,H
	OUT	(0BEH),A
	LD	A,L
	OUT	(0BEH),A
	PUSH	AF
	POP	AF

	DEC	BC
	LD	A,B
	OR	C
	JR	NZ,LPVRMF
	RET
;------------------------------------------------------------------------
;************************************************************************
;* Trans Data For V-RAM							*
;*									*
;************************************************************************
;* IN: HL=Character Data Address					*
;*     DE=V-RAM Address							*
;*     BC=Length							*
;************************************************************************
TRSVDP	RST	008H		;V-RAM Address Set

LPTRSV:	LD	A,(HL)
	OUT	(0BEH),A
	PUSH	AF		;Wait
	POP	AF

	INC	HL
	DEC	BC
	LD	A,B
	OR	C
	JR	NZ,LPTRSV

	RET


;------------------------------------------------------------------------
;************************************************************************
;* Character Pattern Data						*
;*									*
;************************************************************************
CPDATA:	DB	001H,000H,000H,000H,002H,001H,000H,000H
	DB	006H,001H,000H,000H,00CH,003H,000H,000H
	DB	018H,007H,000H,000H,030H,00FH,000H,000H
	DB	031H,00FH,001H,001H,063H,01FH,003H,003H

	DB	0F8H,006H,000H,000H,03DH,0C2H,000H,000H
	DB	01FH,0E0H,000H,000H,01EH,0E1H,000H,000H
	DB	01EH,0E1H,000H,000H,01CH,0E3H,000H,000H
	DB	0BEH,0C1H,080H,080H,0FFH,0F8H,0F8H,0F8H

	DB	0C0H,000H,000H,000H,0F8H,000H,000H,000H
	DB	00EH,0F0H,000H,000H,003H,0FCH,000H,000H
	DB	001H,0FEH,000H,000H,005H,0FEH,004H,004H
	DB	01CH,0FFH,01CH,01CH,070H,0FFH,070H,070H

	DB	000H,000H,000H,000H,000H,000H,000H,000H
	DB	000H,000H,000H,000H,000H,000H,000H,000H
	DB	000H,000H,000H,000H,080H,000H,000H,000H
	DB	0C0H,000H,000H,000H,0C0H,000H,000H,000H

	DB	065H,01AH,005H,005H,0C1H,03FH,001H,001H
	DB	0C0H,03FH,000H,000H,080H,078H,000H,000H
	DB	080H,077H,000H,000H,081H,07FH,000H,000H
	DB	0C0H,038H,000H,000H,0C3H,03BH,003H,003H

	DB	0FEH,0DDH,0DCH,0DCH,07EH,091H,010H,010H
	DB	07EH,081H,000H,000H,07CH,000H,000H,000H
	DB	038H,003H,000H,000H,03FH,0C3H,000H,000H
	DB	03EH,046H,000H,000H,01DH,065H,001H,001H

	DB	050H,0FFH,050H,050H,000H,0FFH,000H,000H
	DB	000H,0FFH,000H,000H,008H,037H,000H,000H
	DB	00CH,0D3H,000H,000H,00CH,0F3H,000H,000H
	DB	006H,009H,000H,000H,0C7H,0C0H,0C0H,0C0H

	DB	0C0H,000H,000H,000H,040H,080H,000H,000H
	DB	060H,080H,000H,000H,020H,0C0H,000H,000H
	DB	020H,0C0H,000H,000H,020H,0C0H,000H,000H
	DB	020H,0C0H,000H,000H,020H,0C0H,000H,000H

	DB	046H,03EH,006H,006H,00EH,03EH,006H,006H
	DB	00EH,01EH,002H,002H,00CH,00CH,000H,000H
	DB	00BH,00BH,004H,000H,007H,007H,000H,000H
	DB	007H,007H,000H,000H,003H,003H,000H,000H

	DB	05FH,047H,041H,041H,09FH,09FH,081H,081H
	DB	01FH,01FH,000H,000H,03FH,03FH,000H,000H
	DB	0DFH,0DFH,000H,000H,06EH,06EH,081H,000H
	DB	0FFH,0FFH,000H,000H,0FFH,0FFH,000H,000H

	DB	09BH,09CH,098H,098H,0AFH,0ABH,000H,000H
	DB	08FH,08BH,080H,080H,01FH,01FH,000H,000H
	DB	0BEH,0BFH,040H,000H,0EEH,0EFH,010H,000H
	DB	0FCH,0FFH,000H,000H,0F8H,0FCH,000H,000H

	DB	0E0H,000H,000H,000H,0C0H,020H,000H,000H
	DB	080H,060H,000H,000H,000H,0C0H,000H,000H
	DB	000H,0C0H,000H,000H,000H,000H,000H,000H
	DB	000H,000H,000H,000H,000H,000H,000H,000H

	DB	001H,001H,000H,000H,000H,000H,000H,000H
	DB	000H,000H,000H,000H,000H,000H,000H,000H
	DB	000H,000H,000H,000H,000H,000H,000H,000H
	DB	000H,000H,000H,000H,000H,000H,000H,000H

	DB	0FFH,0BEH,041H,000H,0FFH,0C1H,03EH,000H
	DB	07FH,07FH,000H,000H,01EH,01EH,000H,000H
	DB	000H,000H,000H,000H,000H,000H,000H,000H
	DB	000H,000H,000H,000H,000H,000H,000H,000H

	DB	0F0H,0F0H,000H,000H,0E0H,0E0H,000H,000H
	DB	080H,080H,000H,000H,000H,000H,000H,000H
	DB	000H,000H,000H,000H,000H,000H,000H,000H
	DB	000H,000H,000H,000H,000H,000H,000H,000H

	DB	000H,000H,000H,000H,000H,000H,000H,000H
	DB	000H,000H,000H,000H,000H,000H,000H,000H
	DB	000H,000H,000H,000H,000H,000H,000H,000H
	DB	000H,000H,000H,000H,000H,000H,000H,000H


;------------------------------------------------------------------------
;************************************************************************
;* Color Data 								*
;*									*
;************************************************************************
CLDATA:	DB	000H,00CH,008H,00BH,037H,003H,000H,000H
	DB	000H,000H,000H,000H,030H,00CH,003H,03FH

	DB	000H,000H,000H,000H,000H,000H,000H,000H
	DB	000H,000H,000H,000H,000H,000H,000H,002H
;------------------------------------------------------------------------

;
;

	ORG	07FF0H
	DB	'Enri Y       ',0FFH,0FFH,0FFH
END